
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef rmp400_TCLSERV_CLIENT_ERROR_H
#define rmp400_TCLSERV_CLIENT_ERROR_H

#include <server/rmp400Error.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum rmp400_error {
	E_rmp400_OK					  			= 0,

	/* module errors */
	E_rmp400_TRACKING_ON                    = S_rmp400_TRACKING_ON,
	E_rmp400_BAD_CMD_PARAMETERS             = S_rmp400_BAD_CMD_PARAMETERS,
	E_rmp400_CANNOT_WRITE_FILE              = S_rmp400_CANNOT_WRITE_FILE,
	E_rmp400_CANNOT_OPEN_FILE               = S_rmp400_CANNOT_OPEN_FILE,
	E_rmp400_CANNOT_READ_POSTER             = S_rmp400_CANNOT_READ_POSTER,
	E_rmp400_GYRO_ERROR                     = S_rmp400_GYRO_ERROR,
	E_rmp400_CMD_STOP_TRACK                 = S_rmp400_CMD_STOP_TRACK,
	E_rmp400_POSTER_NOT_FOUND               = S_rmp400_POSTER_NOT_FOUND,
	E_rmp400_JOYSTICK_ERROR                 = S_rmp400_JOYSTICK_ERROR,
	E_rmp400_RMP_LIB_ERROR                  = S_rmp400_RMP_LIB_ERROR,
	E_rmp400_BAD_REF                        = S_rmp400_BAD_REF,
	E_rmp400_EMERGENCY_ERROR                = S_rmp400_EMERGENCY_ERROR,
	E_rmp400_MOTORS_OFF                     = S_rmp400_MOTORS_OFF,
	E_rmp400_READ_TASK_ERROR                = S_rmp400_READ_TASK_ERROR,
	E_rmp400_RMPLIB_ERROR                   = S_rmp400_RMPLIB_ERROR,
	E_rmp400_EMERGENCY_STOP                 = S_rmp400_EMERGENCY_STOP,


	/* std errors */
	E_rmp400_ACTIVITY_INTERRUPTED           = S_rmp400_stdGenoM_ACTIVITY_INTERRUPTED,
	E_rmp400_TOO_MANY_ACTIVITIES            = S_rmp400_stdGenoM_TOO_MANY_ACTIVITIES,
	E_rmp400_ACTIVITY_FAILED                = S_rmp400_stdGenoM_ACTIVITY_FAILED,
	E_rmp400_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_rmp400_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_rmp400_UNKNOWN_ACTIVITY               = S_rmp400_stdGenoM_UNKNOWN_ACTIVITY,
	E_rmp400_FORBIDDEN_ACTIVITY_TRANSITION  = S_rmp400_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_rmp400_SYSTEM_ERROR                   = S_rmp400_stdGenoM_SYSTEM_ERROR,
	E_rmp400_ACTIVITY_ALREADY_ENDED         = S_rmp400_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_rmp400_WAIT_INIT_RQST                 = S_rmp400_stdGenoM_WAIT_INIT_RQST,
	E_rmp400_CONTROL_CODEL_ERROR            = S_rmp400_stdGenoM_CONTROL_CODEL_ERROR,
	E_rmp400_EXEC_TASK_SUSPENDED            = S_rmp400_stdGenoM_EXEC_TASK_SUSPENDED,
	E_rmp400_BAD_BLOCK_TYPE                 = S_rmp400_stdGenoM_BAD_BLOCK_TYPE,
	E_rmp400_BAD_POSTER_TYPE                = S_rmp400_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum rmp400_error rmp400_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int rmp400_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the rmp400 context.
 *
 * Returns NULL in case of failure
 */
const char* rmp400_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
